;Router Detector alpha 2
;jpd November 2010

IncludeFile "interfaces.pb"
#MIB_TCP_STATE_CLOSED = 1
#MIB_TCP_STATE_LISTEN = 2
#MIB_TCP_STATE_SYN_SENT = 3
#MIB_TCP_STATE_SYN_RCVD = 4
#MIB_TCP_STATE_ESTAB = 5
#MIB_TCP_STATE_FIN_WAIT1 = 6
#MIB_TCP_STATE_FIN_WAIT2 = 7
#MIB_TCP_STATE_CLOSE_WAIT = 8
#MIB_TCP_STATE_CLOSING = 9
#MIB_TCP_STATE_LAST_ACK = 10
#MIB_TCP_STATE_TIME_WAIT = 11
#MIB_TCP_STATE_DELETE_TCB = 12
#MAX_ADAPTER_NAME_LENGTH = 256
#MAX_ADAPTER_DESCRIPTION_LENGTH = 128
#MAX_ADAPTER_ADDRESS_LENGTH = 8
#ERROR_SUCCESS = 0
#MAX_ADAPTER_NAME = 128
#MAX_HOSTNAME_LEN = 128
#MAX_DOMAIN_NAME_LEN = 128
#MAX_SCOPE_ID_LEN = 256



Structure WlanRouter
  WlanInterface.s
  InterfaceGuid.l
  SSID.s
  MAC.s
  Procent.l
  IP.s
  Connected.l
  SaveSetting.s
  Profile.s
EndStructure

Global WlanRouter.WlanRouter







Structure MIB_IPNETROW
  dwIndex.l
  dwPhysAddrLen.l
  bPhysAddr.b[#MAX_ADAPTER_ADDRESS_LENGTH]
  dwAddr.b[4]
  dwType.l
EndStructure
   

Structure MIB_IPNETTABLE
  dwNumEntries.l
  MIB_IPNETROW.MIB_IPNETROW
EndStructure

Global Dim info.s(0)



;Procedure by PB / english forum
Procedure.l hex2dec(h$)
    h$=UCase(h$)
    For r=1 To Len(h$)
        d<<4 : a$=Mid(h$,r,1)
        If Asc(a$)>60
            d+Asc(a$)-55
        Else
            d+Asc(a$)-48
        EndIf
    Next
    ProcedureReturn d
    
EndProcedure

Procedure.s truncate_MAC(MAC.s)
  Protected x
  Protected res_mac.s,tmp_str.s
  For x=1 To 5
    tmp_str=StringField(MAC,x,":")
    If Not x=1
      res_mac=res_mac+":"+tmp_str
    Else
      res_mac=res_mac+tmp_str
    EndIf
    
  Next
  ProcedureReturn res_mac
EndProcedure





Procedure.s arpentries(search_MAC.s) 
  ;Error Goto errhand
Protected lngRetVal.l
Dim arrBuffer.b(0)
lngSize.l
lngRows.l

lngRetVal = GetIpNetTable_(#Null, @lngSize, #Null)
If lngRetVal = #ERROR_NOT_SUPPORTED
        ;'This API works only on Win 98/2000 and NT4 with SP4
        Debug "IP Helper is not supported by this system."
        ProcedureReturn "IP Helper is not supported by this system."
        
EndIf
If lngSize = 0 
    ProcedureReturn  "no arp entry found"
EndIf
;'Prepare the buffer
ReDim arrBuffer(lngSize - 1)
;'And call the function one more time

lngRetVal = GetIpNetTable_(@arrBuffer(0), @lngSize, 0)

If lngRetVal = #ERROR_SUCCESS 
  Protected IPNETTABLE.MIB_IPNETTABLE     
  Protected IPNETROW.MIB_IPNETROW
  Protected i.l
  Protected str.s
  ;'The first 4 bytes (the Long value) contain the quantity of the table rows
  ;CopyMemory(arrBuffer(0), lngRows,  4)
  ;Debug SizeOf(MIB_IPNETROW)
  lngRows= arrBuffer(0)
  ReDim info(lngRows)
  Protected arptype.s
  Protected z.l
  Protected MAC.s
  str = ""
  
  For i = 1 To lngRows
    CopyMemory( @arrBuffer(4 + (i - 1)   * SizeOf(MIB_IPNETROW)),IPNETROW, SizeOf(MIB_IPNETROW))
    ;CopyMemory_any IPNETROW, arrBuffer(4 + (i - 1) * Len(IPNETROW)), Len(IPNETROW)
    str = ""
    ;Debug PeekS(@IPNETROW\bPhysAddr)
    MAC=""
   For z = 0 To IPNETROW\dwPhysAddrLen - 1
     If z=0
      MAC=MAC+ RSet(Hex(IPNETROW\bPhysAddr[z],#PB_Byte),2,"00")
    Else
      MAC=MAC+":"+ RSet(Hex(IPNETROW\bPhysAddr[z],#PB_Byte),2,"00")
    EndIf
   Next 
  ; Debug MAC ;Debug str
   Select IPNETROW\dwType
        Case 1: arptype = "other"
        Case 2: arptype = "invalid"
        Case 3: arptype = "dynamic"
        Case 4: arptype = "static"
        Default: arptype = "unknow"
      EndSelect
      
      For x=0 To 3
        If x=0
          str=str+Str(hex2dec(Hex(PeekB(@IPNETROW\dwAddr[x]),#PB_Byte)))
        Else
          str=str+"."+Str(hex2dec(Hex(PeekB(@IPNETROW\dwAddr[x]),#PB_Byte)))
        EndIf
      Next
      x=0
      ;Debug str+ #TAB$ + MAC +#TAB$+arptype
      Debug search_MAC 
      Debug MAC
      If truncate_MAC(search_MAC)= truncate_MAC(MAC) ;truncate is made while some router have more as 1 mac adress all have the first 5 double same
        ;Debug "Router IP2: "+str
        ;Debug search_MAC 
        ;Debug MAC
        Break 
      EndIf  
      
     ; Debug hex2dec( Hex(PeekB(@IPNETROW\dwAddr[1]),#PB_Byte) )
     ; Debug hex2dec( Hex(PeekB(@IPNETROW\dwAddr[2]),#PB_Byte))
     ; Debug hex2dec( Hex(PeekB(@IPNETROW\dwAddr[3]) ,#PB_Byte))



   ;str = Str(IPNETROW\dwAddr(0)) + "." + Str(IPNETROW\dwAddr(1)) + "." + Str(IPNETROW\dwAddr(2))+ "." + Str(IPNETROW\dwAddr(3)) + ";" + str + ";" + Str(IPNETROW\dwIndex) + ";" + arptype
   info(i) = str
   MAC = ""
 Next i
 If MAC= ""
   ProcedureReturn ""
 Else
   ProcedureReturn str
 EndIf  
Else
  ProcedureReturn "no arp entry found";lngRetVal
EndIf
EndProcedure

;Debug arpentries("00:0F:66:24:DC:74")



EnableExplicit

;  PB Version created by jpd November 2010

#ERROR_SUCCESS  = 0
#DOT11_SSID_MAX_LENGTH  = 32
#WLAN_MAX_PHY_TYPE_NUMBER = 8
#WLAN_AVAILABLE_NETWORK_CONNECTED = 1
#WLAN_AVAILABLE_NETWORK_HAS_PROFILE = 2



Structure  WLAN_INTERFACE_INFO
  InterfaceGuid.guid
  InterfaceDescription.b[512]
  IsState.l
EndStructure

Structure WLAN_INTERFACE_INFO_LIST
  dwNumberOfItems.l
  dwIndex.l
  InterfaceInfo.WLAN_INTERFACE_INFO
EndStructure
  
Structure WLAN_INTERFACE_INFO_LIST_NB
  dwNumberOfItems.l
  dwIndex.l
EndStructure

#dot11_BSS_type_infrastructure   = 1
#dot11_BSS_type_independent      = 2
#dot11_BSS_type_any              = 3 

Structure  DOT11_SSID
  uSSIDLength.l
  ucSSID.b[#DOT11_SSID_MAX_LENGTH]
EndStructure

#DOT11_RATE_SET_MAX_LENGTH = 126


Structure WLAN_RATE_SET
  uRateSetLength.l
  usRateSet.l[#DOT11_RATE_SET_MAX_LENGTH]
EndStructure




Structure WLAN_AVAILABLE_NETWORK
  strProfileName.b[512]
  dot11Ssid.DOT11_SSID
  dot11BssType.l
  uNumberOfBssids.l
  bNetworkConnectable.l
  wlanNotConnectableReason.l
  uNumberOfPhyTypes.l
  dot11PhyTypes.l[#WLAN_MAX_PHY_TYPE_NUMBER ]
  bMorePhyTypes.l
  wlanSignalQuality.l
  bSEcurityEnabled.l
  dot11DefaultAuthAlgorithm.l
  dot11DefaultCipherAlgorithm.l
  dwflags.l
  dwreserved.l
EndStructure
  


#wlan_intf_opcode_current_connection = 7 ;WLAN_CONNECTION_ATTRIBUTES

Structure WLAN_ASSOCIATION_ATTRIBUTES
  dot11Ssid.DOT11_SSID
  dot11BssType.i
  dot11Bssid.c[6]
  dot11PhyType.i
  uDot11PhyIndex.l
  wlanSignalQuality.l
  ulRxRate.l
  ulTxRate.l
EndStructure

Structure WLAN_SECURITY_ATTRIBUTES
  bSecurityEnabled.b
  bOneXEnabled.b
  dot11AuthAlgorithm.l
  dot11CipherAlgorithm.l
EndStructure

Structure WLAN_CONNECTION_ATTRIBUTES
  isState.i
  wlanConnectionMode.i
  strProfileName.s{256}
  wlanAssociationAttributes.WLAN_ASSOCIATION_ATTRIBUTES
  wlanSecurityAttributes.WLAN_SECURITY_ATTRIBUTES
EndStructure



Global ClientHandle.l=0

Define wI_info.WLAN_INTERFACE_INFO

Prototype WlanOpenHandle(dwClientVersion,pReserved,pdwNegotiatedVersion, phClientHandle) 
Prototype WlanCloseHandle(hClientHandle,pReserved)
Prototype WlanEnumInterfaces(hClientHandle,pReserved,ppInterfaceList)
Prototype WlanFreeMemory(pMemory)
Prototype WlanQueryInterface(hClientHandle, pInterfaceGuid, OpCode, pReserved, pdwDataSize, ppData, pWlanOpcodeValueType)
Prototype WlanHostedNetworkQueryStatus(hClientHandle,ppWlanHostedNetworkStatus,pvReserved);
Prototype WlanGetAvailableNetworkList(hClientHandle, pInterfaceGuid, dwFlags, pReserved, ppAvailableNetworkList)
;Prototype WlanScan(hClientHandle, pInterfaceGuid, pDot11Ssid, pIeData, pReserved)
;Prototype WlanGetNetworkBssList(hClientHandle, pInterfaceGuid,pDot11Ssid, dot11BssType, bSecurityEnabled, pReserved, ppWlanBssList)
Prototype WlanReasonCodeToString(dwReasonCode, dwBufferSize, pStringBuffer, pReserved)



Global WlanOpenHandle.WlanOpenHandle
Global WlanCloseHandle.WlanCloseHandle
Global WlanEnumInterfaces.WlanEnumInterfaces
Global WlanFreeMemory.WlanFreeMemory
Global WlanQueryInterface.WlanQueryInterface
Global WlanHostedNetworkQueryStatus.WlanHostedNetworkQueryStatus
Global WlanGetAvailableNetworkList.WlanGetAvailableNetworkList
;Global WlanScan.WlanScan
;Global WlanGetNetworkBssList.WlanGetNetworkBssList
Global WlanReasonCodeToString.WlanReasonCodeToString

;Define.l AskedVersion = 0

Procedure Found_UPnPRouter()
  Protected retval=0
  Protected finder.IUPnPDeviceFinder
  Protected devices.IUPnPDevices
  Protected numdevices
  Protected pUnk.IUnknown
  Protected pEnumVar.IEnumVARIANT
  Protected varCurDevice.VARIANT 
  Protected pDevice.IUPnPDevice
  Protected *pdispDevice.IDispatch
  Protected bstrName
CoInitialize_(0)
If CoCreateInstance_(?CLSID_iupnpdevicefinder, #Null, 1, ?iid_iupnpdevicefinder, @finder.IUPnPDeviceFinder) = #S_OK
  ;Debug "yes"
  
  If finder\FindByType("urn:schemas-upnp-org:device:InternetGatewayDevice:1", 0, @devices.IUPnPDevices) = #S_OK
    
    devices\Count(@numdevices)
    Debug "found "+Str(numdevices)+" Device(s)"
    pUnk.IUnknown
    devices\_NewEnum(@pUnk)
    If pUnk
      pEnumVar.IEnumVARIANT
      pUnk\QueryInterface(?iid_ienumvariant, @pEnumVar)
      If pEnumVar
        varCurDevice.VARIANT 
        pEnumVar\Reset()
        ;// Loop through each device in the collection
        Debug "Mappings on device:"
        While pEnumVar\Next(1, @varCurDevice, #Null) = #S_OK
            pDevice.IUPnPDevice
            *pdispDevice.IDispatch = varcurdevice\pdispVal
            If *pdispdevice
            If *pdispDevice\QueryInterface(?IID_IUPnPDevice, @pDevice) = #S_OK
              If pdevice
                ;// Do something interesting With pDevice
                If pDevice\FriendlyName(@bstrName) = #S_OK
                  Debug PeekS(bstrname, -1, #PB_Unicode)
                  SysFreeString_(bstrname)
                  bstrname = 0
                  If pDevice\UniqueDeviceName(@bstrname) = #S_OK
                    Debug PeekS(bstrname, -1, #PB_Unicode)
                    SysFreeString_(bstrname)
                    retval=1
                  EndIf
                EndIf
                
              EndIf  
            EndIf    
            EndIf
        Wend
        pEnumVar\Release();
      EndIf
      pUnk\Release();
      ;EndIf
    EndIf
    
    devices\Release()
  EndIf
  
  finder\Release()
EndIf

CoUninitialize_()
ProcedureReturn retval
EndProcedure



Procedure LoadWlanapi(Library) 
  Protected Result 

  Result = OpenLibrary(Library, "wlanapi.dll") 
  
  If Result 
    If Library = #PB_Any 
      Library = Result 
    EndIf 
    
    WlanOpenHandle                = GetFunction(Library, "WlanOpenHandle") 
    WlanCloseHandle               = GetFunction(Library, "WlanCloseHandle") 
    WlanEnumInterfaces            = GetFunction(Library, "WlanEnumInterfaces") 
    WlanFreeMemory                = GetFunction(Library, "WlanFreeMemory") 
    WlanQueryInterface            = GetFunction(Library, "WlanQueryInterface") 
    WlanHostedNetworkQueryStatus  = GetFunction(Library, "WlanHostedNetworkQueryStatus") 
    WlanGetAvailableNetworkList   = GetFunction(Library, "WlanGetAvailableNetworkList")
 ;   WlanScan                      = GetFunction(Library, "WlanScan")
  ;  WlanGetNetworkBssList         = GetFunction(Library, "WlanGetNetworkBssList")
    WlanReasonCodeToString        = GetFunction(Library, "WlanReasonCodeToString")
    
    If  WlanOpenHandle = 0 Or  WlanCloseHandle = 0 Or WlanEnumInterfaces = 0 Or WlanFreeMemory = 0 Or WlanQueryInterface = 0 Or WlanHostedNetworkQueryStatus = 0 Or WlanGetAvailableNetworkList = 0  Or WlanReasonCodeToString = 0
      CloseLibrary(Library) 
      Result = 0 
    EndIf      
  EndIf 

  ProcedureReturn Result 
EndProcedure 

Procedure.s GetGUID(guid)
  Protected  lpsz.s{78}
  ProcedureReturn PeekS(@lpsz, StringFromGUID2_(guid, @lpsz, 78), #PB_Unicode)
EndProcedure

#wlan_interface_state_not_ready               = 0
#wlan_interface_state_connected               = 1
#wlan_interface_state_ad_hoc_network_formed   = 2
#wlan_interface_state_disconnecting           = 3
#wlan_interface_state_disconnected            = 4
#wlan_interface_state_associating             = 5
#wlan_interface_state_discovering             = 6
#wlan_interface_state_authenticating          = 7 


Procedure.s  WLAN_INTERFACE_STATE(Value.l)
  Protected Rets.s 
  Protected state.l=0
  Select Value
    Case  #wlan_interface_state_not_ready ;              = 0,
      Rets="wlan interface state not ready"
    Case #wlan_interface_state_connected 
      state=1
      ;WlanRouter\Connected=1
      
      Rets="wlan interface state connected"
    Case #wlan_interface_state_ad_hoc_network_formed;   = 2,
      Rets="wlan interface state ad hoc network formed"
    Case #wlan_interface_state_disconnecting;           = 3,
      Rets="wlan interface state disconnecting"
    Case #wlan_interface_state_disconnected;            = 4,
      Rets="wlan interface state disconnected"
    Case #wlan_interface_state_associating;             = 5,
      Rets="wlan interface state associating"
    Case #wlan_interface_state_discovering;             = 6,
      Rets="wlan interface state discovering"
    Case #wlan_interface_state_authenticating;          = 7 
      Rets="wlan interface state authenticating"
  EndSelect
  WlanRouter\Connected=state
  ProcedureReturn Rets
EndProcedure



Procedure.s MacToString(*membuffer)
  Protected MAC.s=""
  Protected i
  For i=0 To 5
    MAC+RSet(Hex(PeekB(*membuffer+i)&$FF),2,"0")
    If i<5
      MAC+":"
    EndIf
  Next
  ProcedureReturn MAC
 
EndProcedure

Procedure  Terminate_enumeration()
  Protected lRet.l
  lRet = WlanCloseHandle(ClientHandle, #Null)
  Debug GetLastError_()
  If lRet <> #ERROR_SUCCESS
    Debug "Error on function WlanCloseHandle :" +Str(lRet)
  EndIf
  ;End 
EndProcedure


Procedure.s Wlan_Query_interface(pInterfaceGuid)
  Protected lRet.l
  Protected datasize.l=0
  Protected ppdata.l
  Protected opvalue.l
  Protected connection.WLAN_CONNECTION_ATTRIBUTES
  Protected MAC.s

  
  lRet = WlanQueryInterface(ClientHandle, pInterfaceGuid,#wlan_intf_opcode_current_connection, #Null, @datasize,@ppdata,@opvalue.l)
  ;The caller is responsible For using WlanFreeMemory To free the memory allocated For ppData.
  Debug GetLastError_()
  
  #ERROR_INVALID_STATE= 5023 

  
  If lRet <> #ERROR_SUCCESS
    Debug "Error function WlanGetAvailableNetworkList :" +Str(lRet)
    ProcedureReturn ""
  EndIf
  
  CopyMemory(ppdata, connection ,SizeOf(WLAN_CONNECTION_ATTRIBUTES))
  
  ;Debug PeekS(@connection\wlanAssociationAttributes\dot11Ssid\ucSSID[0],-1,#PB_Ascii)
  MAC= MacToString(@connection\wlanAssociationAttributes\dot11Bssid)
  Debug "WLan Adapter Index: "+Str(connection\wlanAssociationAttributes\uDot11PhyIndex)
  Debug "WLan Signal quality: "+Str(connection\wlanAssociationAttributes\wlanSignalQuality)+"%"
  WlanFreeMemory(ppdata)
  ProcedureReturn MAC
EndProcedure  
Procedure Enumerate_interface()
    Protected list_interface.WLAN_INTERFACE_INFO_LIST_NB
    Protected pList_interface.l
    Protected lRet.l
    Shared wI_info.WLAN_INTERFACE_INFO
    Protected stGuid.s
    Protected stEtat.s
    Protected Dim wiInterfaces.WLAN_INTERFACE_INFO(0)
    Protected iInterface.l
    Protected connected.l=0
    lRet = WlanEnumInterfaces(ClientHandle, #Null, @pList_interface)


    If lRet <> #ERROR_SUCCESS
        Debug "Error function WlanEnumInterfaces :" +Str(lRet)
        ProcedureReturn connected
    EndIf
    
    CopyMemory(pList_interface, list_interface,SizeOf(WLAN_INTERFACE_INFO_LIST_NB))
    Debug "Number of Wifi interface: " +Str(list_interface\dwNumberOfItems)
    
    If list_interface\dwNumberOfItems = 0 
      Debug "---------------- No Wifi interface ---------------"
      ProcedureReturn connected
    EndIf
    
    ReDim wiInterfaces(list_interface\dwNumberOfItems - 1)
    CopyMemory(pList_interface + SizeOf(WLAN_INTERFACE_INFO_LIST_NB), wiInterfaces(0), SizeOf(WLAN_INTERFACE_INFO) * list_interface\dwNumberOfItems)
    For iInterface = 0 To list_interface\dwNumberOfItems - 1
      Debug "------------------------------------------------"
      Debug "interface Nr: " +Str(iInterface)
      wI_info = wiInterfaces(iInterface)
      Debug "GUID :"+GetGUID(wI_info\InterfaceGuid)
      Debug "interface Wifi Description :" + PeekS(@wI_info\InterfaceDescription,-1,#PB_Unicode)
      WlanRouter\WlanInterface=PeekS(@wI_info\InterfaceDescription,-1,#PB_Unicode)
      Debug "Interface Wifi State: "+WLAN_INTERFACE_STATE(wI_info\IsState)
      If wI_info\IsState = 1
        WlanRouter\Connected=1
        WlanRouter\InterfaceGuid=wI_info\InterfaceGuid
        ;MAC=Wlan_Query_interface(wI_info\InterfaceGuid)
        connected=1
      Else
        connected=0
      EndIf  
      ;Enumerate_Network(wI_info\InterfaceGuid)
      ;Enumerate_NetworkBssList(wI_info\InterfaceGuid)
      ;WlanFreeMemory(pList_interface)
    Next
    ProcedureReturn connected
EndProcedure
  
Procedure ProbePort(IP.s, Port.l) 
  Protected ConID.l 
  Protected RetCode.l=0
  ConID = OpenNetworkConnection(IP, Port) 
  If ConID 
    Debug Str(Port) 
    RetCode=1
    CloseNetworkConnection(ConID) 
  EndIf 
  ProcedureReturn RetCode
EndProcedure 



Procedure WlanManager()
  Protected lRet.l=0
  Protected AskedVersion.l
  Shared wI_info.WLAN_INTERFACE_INFO
  If OSVersion() =#PB_OS_Windows_XP
    AskedVersion=1
  ElseIf    OSVersion() =#PB_OS_Windows_Vista Or OSVersion() = #PB_OS_Windows_7 Or OSVersion()=#PB_OS_Windows_Server_2008 
    AskedVersion=2
  EndIf

  If LoadWlanapi(0) 
  
  Define    NegotiatedVersion.l=0
  Define MAC.s, RouterIP.s
  Define noTryagain=0
  lRet = WlanOpenHandle(AskedVersion, #Null, @NegotiatedVersion, @ClientHandle)
  If lRet <> #ERROR_SUCCESS
    Debug "Error function WlanOpenHandle :" +Str(lRet)
    CloseLibrary(0)
    ProcedureReturn 0
  EndIf
  Debug "version of WLAN asked is: " + Str(AskedVersion) + "version  obtained : " + Str(NegotiatedVersion)
  ;mac.s= Enumerate_interface()
  If Enumerate_interface()
    Debug "connected"  
    ;Wlan_Query_interface(wI_info\InterfaceGuid)
    MAC=Wlan_Query_interface(WlanRouter\InterfaceGuid)

  EndIf  
  
  Terminate_enumeration()
  ReCheckMAC:
  If mac <> "" 
    RouterIP=arpentries(mac)
    Debug "Router IP: " +RouterIP
    If Not RouterIP = ""
      If ProbePort(RouterIP,80)
        Debug "try to connect.."
        RunProgram("http://"+RouterIP,"","")
      EndIf
    Else
      
      Debug "No Router IP found.."
      If noTryagain=0
        If Found_UPnPRouter()
          noTryagain=1
          Goto ReCheckMAC
        EndIf
      EndIf
      
    EndIf  

    
  Else
    Debug "No MAC"
  EndIf  
  CloseLibrary(0) 
  
Else
  Debug "load failed"
EndIf   
EndProcedure

InitNetwork()


WlanManager()


; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 1
; Folding = ---
; EnableUnicode
; EnableXP